searchNodes=[{"doc":"This is the base Nerves System configuration for the MangoPi MQ Pro . This is a work in progress. It may change in backwards incompatible ways and the documentation might be lacking. To do: [x] Bring up WiFi [x] Verify Blue PWM LED [?] Fix MicroSD flakiness on boot (seems much better now?) [x] Verify USB host-only port (works with USB Flash drive) [x] Fix USB gadget mode on OTG port [x] Verify SPI (spidev1.0 and spidev1.1) [x] Verify I2C [ ] Verify all GPIO work (GPIO inputs seem to work) [x] Verify HW watchdog [x] Check that TARGET_GCC_FLAGS are right [x] Update Linux kernel to 5.18 [x] Implement A/B firmware updates work [x] Use SID for serial number [ ] Reduce prints and shorten boot time [ ] Verify HDMI [ ] Verify camera &lt;sup&gt;[Image credit](#mangopi)&lt;/sup&gt; Feature Description CPU 1 GHz 64 bit RISC-V Memory 512 MB or 1 GB DRAM Storage MicroSD Linux kernel 5.19 w/ patches IEx terminal UART ttyS0 GPIO, I2C, SPI Yes - Elixir Circuits Display Yes, but not supported yet ADC No PWM Yes, but no Elixir support UART ttyS0 Camera Yes, but not supported yet Ethernet No WiFi Onboard WiFi RTC No HW Watchdog Yes","ref":"readme.html","title":"MangoPi MQ Pro Support","type":"extras"},{"doc":"The most common way of using this Nerves System is create a project with mix nerves.new and add mangopi references where needed and in a similar way to the default systems like bbb , etc. Then export MIX_TARGET=mangopi . See the Getting started guide for more information. If you need custom modifications to this system for your device, clone this repository and update as described in Making custom systems .","ref":"readme.html#using","title":"MangoPi MQ Pro Support - Using","type":"extras"},{"doc":"This example assumes some familiarity with Nerves. To use this system, you'll need OTP 25. Follow the Nerves installation instructions for additional system dependencies. Creating a new hello world application: mix nerves.new hello_mango cd hello_mango Open up your mix.exs and add :mangopi_mq_pro to the @all_targets list at the top. It's ok to delete targets that you don't plan on using. Then add the :nerves_system_mango_mq_pro dependency to the deps function: { :nerves_system_mangopi_mq_pro , &quot;~&gt; 0.1&quot; , runtime : false , targets : :mangopi_mq_pro } , This will load the latest released version. To use the latest code on the main branch here, add the following line: { :nerves_system_mangopi_mq_pro , runtime : false , targets : :mangopi_mq_pro , nerves : [ compile : true ] , git : &quot;https://github.com/fhunleth/nerves_system_mangopi_mq_pro&quot; , branch : &quot;main&quot; } To build and write to a MicroSD card, run: export MIX_TARGET=mangopi_mq_pro mix deps.get mix firmware mix burn","ref":"readme.html#example-use","title":"MangoPi MQ Pro Support - Example use","type":"extras"},{"doc":"The console is configured to output to the UART on pins 8 and 10 on the 40-pin GPIO connector. This is just like the Raspberry Pi. A 3.3V FTDI cable is needed to access the output.","ref":"readme.html#console-access","title":"MangoPi MQ Pro Support - Console access","type":"extras"},{"doc":"The board has two network interfaces, a WiFi module and a virtual Ethernet on the USB C connector marked &quot;OTG&quot;. If virtual Ethernet isn't working for you, try a different USB cable. You're welcome.","ref":"readme.html#networking","title":"MangoPi MQ Pro Support - Networking","type":"extras"},{"doc":"The following table is a mapping between the logical GPIO numbers used in software (sysfs, Circuits.GPIO), and the pin numbers on the 20x2 Raspberry Pi header. For example, to control pin 11 you would open a connection to GPIO 117: { :ok , pin } = Circuits.GPIO . open ( 117 , :output ) GPIO Pin Pin GPIO 1 2 205 3 4 204 5 6 39 7 8 40 9 10 41 117 11 12 37 118 13 14 32 15 16 33 17 18 110 19 20 21 22 65 23 24 25 26 111 145 27 28 144 42 29 30 43 31 32 64 44 33 34 38 35 36 34 113 37 38 35 39 40 36","ref":"readme.html#gpio","title":"MangoPi MQ Pro Support - GPIO","type":"extras"},{"doc":"Schematics IBOM - Interactive web page to help you find what part is located where D1 documentation","ref":"readme.html#schematics-and-datasheets","title":"MangoPi MQ Pro Support - Schematics and datasheets","type":"extras"},{"doc":"The most helpful Allwinner D1 information comes from linux-sunxi.org/Allwinner_Nezha . All of the work here wouldn't have been possible with out it. Thanks especially to smaeul's Allwinner D1 Linux fork Here are more useful links: bret.dk's ARMBian post NixOS on D1 YuzukiHD Buildroot DongshanPI Store Image credit : This image is from mangopi.cc .","ref":"readme.html#thanks","title":"MangoPi MQ Pro Support - Thanks","type":"extras"},{"doc":"This project does NOT follow semantic versioning. The version increases as follows: Major version updates are breaking updates to the build infrastructure. These should be very rare. Minor version updates are made for every major Buildroot release. This may also include Erlang/OTP and Linux kernel updates. These are made four times a year shortly after the Buildroot releases. Patch version updates are made for Buildroot minor releases, Erlang/OTP releases, and Linux kernel updates. They're also made to fix bugs and add features to the build infrastructure.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.20.6 Erlang/OTP 25.0.4 Buildroot 2022.05.2 Also see Buildroot 2022.05.1 changes","ref":"changelog.html#v0-2-5","title":"Changelog - v0.2.5","type":"extras"},{"doc":"Fixes Fix USB gadget mode on MacOS","ref":"changelog.html#v0-2-4","title":"Changelog - v0.2.4","type":"extras"},{"doc":"This release synchronizes the device tree configuration with upstream's new MangoPi MQ Pro device tree. This has at least two noticable changes: The Blue LED is now called &quot;:status&quot; . It was &quot;blue:indicator&quot; so any references will need to be updated. The SPI device that's on the GPIO header pins is now spidev0 . This makes it the same as the Raspberry Pi, so this was a welcome change. Updates Update Linux to smauel's wip-all branch. This is currently his latest and it includes device tree updates specifically for the MangoPi MQ Pro. Serial numbers are now 8 hex digits since collisions were found with just 4. USB Gadget mode works on the OTG port (right-most port) Reverting firmware works now","ref":"changelog.html#v0-2-3","title":"Changelog - v0.2.3","type":"extras"},{"doc":"Updates Various deletions to the device tree to free up GPIOs that weren't used. Fix I2C0 pins Updated dependencies nerves_system_br v1.20.4 Erlang/OTP 25.0.3","ref":"changelog.html#v0-2-2","title":"Changelog - v0.2.2","type":"extras"},{"doc":"This release has several updates, but mostly makes it possible to use SPI now. Updates Linux 5.19-rc0 (smauel's wip-d1 Linux branch) SPI1 works now through the GPIO header Clean up DTB handling. The U-Boot device tree is the only one that's used so all patching and building of the Linux one has been removed. Also U-Boot is updated on firmware updates. This isn't good, but it's easier than reburning the MicroSD card every time.","ref":"changelog.html#v0-2-1","title":"Changelog - v0.2.1","type":"extras"},{"doc":"This release updates the Linux kernel to 5.18 in the hopes of fixing some Linux kernel flakiness. U-Boot has changed enough that I don't believe that a v0.1.1 image is upgradable. Please rewrite your MicroSD image. Updates Linux 5.18-rc4 (smauel's wip-d1 Linux branch) Switch to the Nezha device tree since upstream updates have fixed the warnings that caused me to create a custom dts. Enable earlycon for earlier logging from Linux","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"The release fixes some issues that made v0.1.0 hard to use. The flaky MMC boot issue is still present. If your board hits it, unplugging and replugging in the MicroSD card has been found to be a more reliable workaround than rebooting. Updates Enable the RISC-V vector extension Fixes Fix compilation warnings when using C standard headers. If a library had -Werror , these would end up breaking Elixir libraries that had C/C++ code. Make sure that the watchdog is active during boot and can't be disabled. This recovers (with a reboot) from some more hangs.","ref":"changelog.html#v0-1-1","title":"Changelog - v0.1.1","type":"extras"},{"doc":"This is the initial release.","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]